//"client" : imdisk -a -t proxy -o shm -o ro -f test_proxy -m Z:
//"server" : devio --dll=proxy.dll;dllopen shm:test_proxy c:\test.vmdk
//sourcecode for libewf unit here : http://labalec.fr/erwan/?p=1235

library proxy;

uses
  SysUtils,
  Classes,
  windows,
  LibVMDK in '..\..\libvmdk\libvmdk.pas';

{$R *.res}

type
  dllread_proc = function (handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
  dllwrite_proc = function (handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
  dllclose_proc = function (handle:thandle): integer; cdecl;

var
file_handle:thandle;
vmdk:TLibVMDK;


function my_read_proc(handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
begin
	writeln('Read request - size:'+inttostr(size)+' offset:'+inttostr(offset));
	result:=vmdk.libvmdk_read_random (buf,size,offset);
end;

function my_write_proc(handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
begin
  //not write support yet - open as read only
	writeln('Write request - size:'+inttostr(size)+' offset:'+inttostr(offset));
	//result:=ewf.libewf_write_random(buf,size,offset);
  result:=size;
end;

function my_close_proc(handle:thandle): integer; cdecl;
begin
	writeln('Close request');
	vmdk.destroy ;
	result:=0;
end;

function dllopen(filename:pchar; read_only:integer; var dllread:dllread_proc; var dllwrite:dllwrite_proc; var dllclose:dllclose_proc; var size:int64):thandle;cdecl;
var
value:ansistring;
begin
	writeln('File to open: '+ansistring(filename));

	dllread := my_read_proc;
	dllwrite := my_write_proc;
	dllclose := my_close_proc;

  vmdk:=TLibvmdk.create ;
  if vmdk.libvmdk_open_wide(widestring(filename),LIBVMDK_OPEN_READ )<>0
    then writeln('TLibvmdk NOK')
    else Writeln('TLibvmdk OK');
  if vmdk.libvmdk_open_extent_data_files <>1 then writeln('Unable to open extent data files');
  size:=vmdk.libvmdk_get_media_size ;
  writeln('size: '+inttostr(size));

	result:=1;
end;

exports
  dllopen index 1;

begin
end.
